<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Commanders: EventStack Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Commanders
   </div>
   <div id="projectbrief">Arduino buttons/bus library</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('classEventStack.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-attribs">Static Public Attributes</a> &#124;
<a href="classEventStack-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">EventStack Class Reference</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">

<p><code>#include &quot;<a class="el" href="EventStack_8hpp_source.html">EventStack.hpp</a>&quot;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ae68541fb067cda62a399a9cea46ca202"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classEventStack.html#ae68541fb067cda62a399a9cea46ca202">PushEvent</a> (unsigned long inId, <a class="el" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490c">COMMANDERS_EVENT_TYPE</a> inType, int inData)</td></tr>
<tr class="separator:ae68541fb067cda62a399a9cea46ca202"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0cd732c42b231ae7e31ec5b77d23faec"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classEventStack.html#a0cd732c42b231ae7e31ec5b77d23faec">GetEvent</a> (byte inIndex, unsigned long *inpId, <a class="el" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490c">COMMANDERS_EVENT_TYPE</a> *inpType, int *inpData)</td></tr>
<tr class="separator:a0cd732c42b231ae7e31ec5b77d23faec"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac926c16835a21a1710d986040ce76b57"><td class="memItemLeft" align="right" valign="top">byte&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classEventStack.html#ac926c16835a21a1710d986040ce76b57">GetPendingEventIndex</a> ()</td></tr>
<tr class="separator:ac926c16835a21a1710d986040ce76b57"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-attribs"></a>
Static Public Attributes</h2></td></tr>
<tr class="memitem:aa069fd5ec754f59e4285bc3a38ff1b78"><td class="memItemLeft" align="right" valign="top">static EventStack&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classEventStack.html#aa069fd5ec754f59e4285bc3a38ff1b78">EventsStack</a></td></tr>
<tr class="separator:aa069fd5ec754f59e4285bc3a38ff1b78"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>The event stack is a small location for a few events ready to be send to the caller. This is a barely a list. If the 'id' for the given index is <a class="el" href="Events_8h.html#a48ad4dd16b8e22f2c8bc92b154479e92">UNDEFINED_ID</a>, so no event is defined at this index. Each RaiseEvent will be push the new one in the first free index of the list. Each <a class="el" href="classEventStack.html#ae68541fb067cda62a399a9cea46ca202">PushEvent</a> will returns the first not free event content, and free the event list for this index. There is no priority in the list... </p>

<p class="definition">Definition at line <a class="el" href="EventStack_8hpp_source.html#l00019">19</a> of file <a class="el" href="EventStack_8hpp_source.html">EventStack.hpp</a>.</p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a0cd732c42b231ae7e31ec5b77d23faec"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void EventStack::GetEvent </td>
          <td>(</td>
          <td class="paramtype">byte&#160;</td>
          <td class="paramname"><em>inIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned long *&#160;</td>
          <td class="paramname"><em>inpId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490c">COMMANDERS_EVENT_TYPE</a> *&#160;</td>
          <td class="paramname"><em>inpType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int *&#160;</td>
          <td class="paramname"><em>inpData</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Gets the given event from the stack, at the given index. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">inIndex</td><td>index of the event to get. </td></tr>
    <tr><td class="paramname">inpId</td><td>address to fill with the id of the event </td></tr>
    <tr><td class="paramname">inpType</td><td>address to fill with the type </td></tr>
    <tr><td class="paramname">inpData</td><td>address to fill with the associated data </td></tr>
  </table>
  </dd>
</dl>
<dl class="section remark"><dt>Remarks</dt><dd>A previous call to <a class="el" href="classEventStack.html#ac926c16835a21a1710d986040ce76b57">GetPendingEventIndex()</a> will give the first available event index. </dd></dl>

<p class="definition">Definition at line <a class="el" href="EventStack_8cpp_source.html#l00037">37</a> of file <a class="el" href="EventStack_8cpp_source.html">EventStack.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="ac926c16835a21a1710d986040ce76b57"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">byte EventStack::GetPendingEventIndex </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Gets the first available event index in the stack. There is no history of stack filling, so the first one is not necessary the oldest in the list... </p>

<p class="definition">Definition at line <a class="el" href="EventStack_8cpp_source.html#l00028">28</a> of file <a class="el" href="EventStack_8cpp_source.html">EventStack.cpp</a>.</p>

</div>
</div>
<a class="anchor" id="ae68541fb067cda62a399a9cea46ca202"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void EventStack::PushEvent </td>
          <td>(</td>
          <td class="paramtype">unsigned long&#160;</td>
          <td class="paramname"><em>inId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="Events_8h.html#a36239a7eea6194f04e73e80d7419490c">COMMANDERS_EVENT_TYPE</a>&#160;</td>
          <td class="paramname"><em>inType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>inData</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Add a new event to the stack. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">inId</td><td>id of the event </td></tr>
    <tr><td class="paramname">inType</td><td>type </td></tr>
    <tr><td class="paramname">inData</td><td>associated data </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="EventStack_8cpp_source.html#l00012">12</a> of file <a class="el" href="EventStack_8cpp_source.html">EventStack.cpp</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a class="anchor" id="aa069fd5ec754f59e4285bc3a38ff1b78"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">EventStack EventStack::EventsStack</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Stack of events itself. </p>

<p class="definition">Definition at line <a class="el" href="EventStack_8hpp_source.html#l00036">36</a> of file <a class="el" href="EventStack_8hpp_source.html">EventStack.hpp</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>D:/Mes documents/Trusty/Arduino/Libraries/Commanders/src/<a class="el" href="EventStack_8hpp_source.html">EventStack.hpp</a></li>
<li>D:/Mes documents/Trusty/Arduino/Libraries/Commanders/src/<a class="el" href="EventStack_8cpp_source.html">EventStack.cpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="classEventStack.html">EventStack</a></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:55:02 for Commanders &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
